IMPLEMENTATION MODULE WinOut;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    *************************************************************************
    A.Iakovlev  Ver  1.0  Derived from module WinIO             January 90
    A.Iakovlev  Ver  2.0  Attributes by value                   February 90
    A.Iakovlev  Ver  3.0  Procedures Clear and Roll             February 90
    A.Iakovlev  Ver  4.0  Changes in attributes                 February 90
    A.Iakovlev  Ver  4.1  Use new module Win                    February 90
    A.Iakovlev  Ver  5.0  Renaming                              February 90
    A.Iakovlev  Ver  6.0  Icons output                          February 90
    A.Iakovlev  Ver  7.0  No moving in Char and String          March 90
    A.Iakovlev  Ver  7.1  Monitor results in module Win         March 90
    A.Iakovlev  Ver  7.2  New module RD                         June 90
    A.Iakovlev  Ver  8.0  Rectangle in procedure Roll           August 90
    A.Iakovlev  Ver  9.0  Procedure PattRect                    October 90
    A.Iakovlev  Ver 10.0  Screen level redesign                 October 90
    A.Iakovlev  Ver 11.0  Procedure Ellipse                     October 90
    A.Iakovlev  Ver 12.0  Procedure FillCircle                  October 90
    A.Iakovlev  Ver 13.0  Procedure FillEllipse                 November 90
    A.Iakovlev  Ver 14.0  No procedures Circle and FillCircle   November 90
    A.Iakovlev  Ver 15.0  Procedures Polyline and Polygon       November 90
    A.Iakovlev  Ver 16.0  No procedure Icon                     February 91
    A.Iakovlev  Ver 16.1  Use new module Win                    February 91
    A.Iakovlev  Ver 17.0  Renaming pattern -> hatch             February 91
    A.Iakovlev  Ver 17.1  New type Win.Inland                   March 91
    A.Iakovlev  Ver 18.0  Status in Polyline/Polygon            June 92
    A.Iakovlev  Ver 19.0  Procs MaxSize for Polyline/Polygon    June 92
    A.Iakovlev  Ver 20.0  Use module Res                        August 92
    A.Iakovlev  Ver 21.0  Renaming                              June 93
    A.Iakovlev  Ver 22.0  Use Scr.Pixel                         September 94
    A.Iakovlev  Ver 23.0  No procedure StippledRect             March 95
    A.Iakovlev  Ver 24.0  New module ScrOut                     March 95
    ************************************************************************
  *)

  IMPORT Geo, Res, Scr, ScrOut, Win;

  PROCEDURE Marker(u: Win.WINDOW; a: ScrOut.Attrs; p: Geo.Point);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      INC(p.ix, i.org.ix);
      INC(p.iy, i.org.iy);
      ScrOut.Marker(i.pixmap, a, p);
      Win.Release(u);
    END Marker;

  PROCEDURE Line(u: Win.WINDOW; a: ScrOut.Attrs; p1, p2: Geo.Point);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      INC(p1.ix, i.org.ix);
      INC(p1.iy, i.org.iy);
      INC(p2.ix, i.org.ix);
      INC(p2.iy, i.org.iy);
      ScrOut.Line(i.pixmap, a, p1, p2);
      Win.Release(u);
    END Line;

  PROCEDURE Rectangle(u: Win.WINDOW; a: ScrOut.Attrs; r: Geo.Rectangle);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      Geo.ShiftRect(r, i.org.ix, i.org.iy);
      ScrOut.Rectangle(i.pixmap, a, r);
      Win.Release(u);
    END Rectangle;

  PROCEDURE Ellipse(u: Win.WINDOW; a: ScrOut.Attrs; p: Geo.Point; a0, b0: CARDINAL);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      INC(p.ix, i.org.ix);
      INC(p.iy, i.org.iy);
      ScrOut.Ellipse(i.pixmap, a, p, a0, b0);
      Win.Release(u);
    END Ellipse;

  PROCEDURE Polyline(u: Win.WINDOW; a: ScrOut.Attrs;
                     ps: ARRAY OF Geo.Point; first, last: CARDINAL;
                     close: BOOLEAN): Res.Status;
    VAR
      i: Win.Inland;
      k: CARDINAL;
      s: Res.Status;
    BEGIN
      Win.Get(u, i);
      FOR k := first TO last DO
        INC(ps[k].ix, i.org.ix);
        INC(ps[k].iy, i.org.iy);
      END;
      s := ScrOut.Polyline(i.pixmap, a, ps, first, last, close);
      Win.Release(u);
      RETURN s;
    END Polyline;

  PROCEDURE PolylineMaxSize(): CARDINAL;
    BEGIN
      RETURN ScrOut.PolylineMaxSize();
    END PolylineMaxSize;

  PROCEDURE FillRectangle(u: Win.WINDOW; a: ScrOut.Attrs; r: Geo.Rectangle);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      Geo.ShiftRect(r, i.org.ix, i.org.iy);
      ScrOut.FillRectangle(i.pixmap, a, r);
      Win.Release(u);
    END FillRectangle;

  PROCEDURE FillEllipse(u: Win.WINDOW; a: ScrOut.Attrs; p: Geo.Point; a0, b0: CARDINAL);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      INC(p.ix, i.org.ix);
      INC(p.iy, i.org.iy);
      ScrOut.FillEllipse(i.pixmap, a, p, a0, b0);
      Win.Release(u);
    END FillEllipse;

  PROCEDURE FillPolygon(u: Win.WINDOW; a: ScrOut.Attrs;
                        ps: ARRAY OF Geo.Point; first, last: CARDINAL): Res.Status;
    VAR
      i: Win.Inland;
      k: CARDINAL;
      s: Res.Status;
    BEGIN
      Win.Get(u, i);
      FOR k := first TO last DO
        INC(ps[k].ix, i.org.ix);
        INC(ps[k].iy, i.org.iy);
      END;
      s := ScrOut.FillPolygon(i.pixmap, a, ps, first, last);
      Win.Release(u);
      RETURN s;
    END FillPolygon;

  PROCEDURE FillPolygonMaxSize(): CARDINAL;
    BEGIN
      RETURN ScrOut.FillPolygonMaxSize();
    END FillPolygonMaxSize;

  PROCEDURE Char(u: Win.WINDOW; a: ScrOut.Attrs; p: Geo.Point; ch: CHAR);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      INC(p.ix, i.org.ix);
      INC(p.iy, i.org.iy);
      ScrOut.Char(i.pixmap, a, p, ch);
      Win.Release(u);
    END Char;

  PROCEDURE String(u: Win.WINDOW; a: ScrOut.Attrs; p: Geo.Point; s: ARRAY OF CHAR);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      INC(p.ix, i.org.ix);
      INC(p.iy, i.org.iy);
      ScrOut.String(i.pixmap, a, p, s);
      Win.Release(u);
    END String;

  PROCEDURE Clear(u: Win.WINDOW; c: Scr.Pixel);
    VAR
      i: Win.Inland;
    BEGIN
      Win.Get(u, i);
      Scr.SolidRect(i.pixmap, i.port, c, Scr.copy);
      Win.Release(u);
    END Clear;

  PROCEDURE Roll(u: Win.WINDOW; r: Geo.Rectangle; dx, dy: INTEGER);
    VAR
      i: Win.Inland;
      p: Geo.Point;
    BEGIN
      IF (dx # 0) OR (dy # 0) THEN
        Win.Get(u, i);
        Geo.ShiftRect(r, i.org.ix, i.org.iy);
        IF Geo.RectXRectRes(r, i.port, r) AND Geo.ShiftXRect(r, dx, dy) THEN
          p.ix := r.ixMin - dx;
          p.iy := r.iyMin - dy;
          Scr.RectCopy(i.pixmap, r, i.pixmap, p, Scr.copy);
        END;
        Win.Release(u);
      END;
    END Roll;

  END WinOut.
